Index: main/plugin-core-ui/resources/js/Ametys/form/ConfigurableFormPanel.js
===================================================================
--- main/plugin-core-ui/resources/js/Ametys/form/ConfigurableFormPanel.js	(revision 32647)
+++ main/plugin-core-ui/resources/js/Ametys/form/ConfigurableFormPanel.js	(working copy)
@@ -57,6 +57,14 @@
          * @readonly 
          */
         LABEL_WIDTH: 200,
+        
+        /**
+         * @property {Number} LABEL_PADDING The padding for field labels 
+         * @private
+         * @readonly 
+         */
+        LABEL_PADDING: 5,
+        
         /**
          * @property {Number} FIELD_MINWIDTH The minimum width for fields
          * @private
@@ -138,11 +146,6 @@
      */
     
     /**
-     * @property {Object} _switchers The group switchers are a map of fields that switches their group. A mapping between a field name and the Ext.form.Field value.
-     * @private
-     */
-    
-    /**
      * @property {Ametys.form.ConfigurableFormPanel.ParameterCheckersDAO} _paramCheckersDAO The istance of the parameters checkers DAO of this form
      * @private
      */
@@ -223,7 +226,6 @@
         this._fields = [];  
         this._repeaters = [];
         this._tabPanels = [];
-        this._switchers = {};
 
         this._paramCheckersDAO = Ext.create('Ametys.form.ConfigurableFormPanel.ParameterCheckersDAO', {
             form: this
@@ -339,31 +341,6 @@
     },
     
     /**
-     * Get a field in this form by id or name
-     * @param {String} name The name (or id) of the searched field
-     * @return {Ext.form.field.Field} The first matching field or switcher, or null if none was found.
-     */
-    getField: function (name)
-    {
-        return this._switchers.hasOwnProperty(name) ? this._switchers[name] : this.getForm().findField(name);
-    },
-    
-    /**
-     * Get all the fields of the form, including the switchers
-     * @return {Ext.form.field.Field[]} An array of fields
-     */
-    getFields: function ()
-    {
-        var fields = this.getForm().getFields();
-        
-        Ext.Object.each(this._switchers, function(fieldName) {
-            fields.push(this[fieldName]);
-        });
-    
-        return fields;  
-    },
-    
-    /**
      * Call Ext.form.field.Field.markInvalid on all fields of the form that are in error
      * @param {Object} fieldsInError The fields in error: the key is the name and the value is the error message.
      */
@@ -371,7 +348,7 @@
     {
         for (var name in fieldsInError)
         {
-            var fd = this.getField (name);
+            var fd = this.getForm().findField(name);
             if (fd)
             {
                 fd.markInvalid (fieldsInError[name])
@@ -678,11 +655,11 @@
     {
         var panelContainers = panel.query('container'),
             paramCheckers = [];
-        
+
         Ext.Array.each(panelContainers, function(container){
             if (container.hasCls('param-checker-container'))
             {
-                paramCheckers.push(container.down().paramChecker);
+                paramCheckers.push(container.down('button').paramChecker);
             }
         });
         
@@ -835,37 +812,33 @@
             header[startup ? 'addCls' : 'removeCls']('startup');
             header[startup ? 'removeCls' : 'addCls']('not-startup');
             
-            var hasError = errorFields.length > 0;
-            var hasWarn = warnFields.length > 0;
+            var errors = Ext.Array.union(errorFields, testsErrorMessages);
+            var warnings = Ext.Array.union(warnFields, testsWarnMessages);
+            
+            var hasError = errors.length > 0;
+            var hasWarn = warnings.length > 0;
             var hasComment = commentFields.length > 0;
             
-            var headerCls = '';
+            header.removeCls(['error', 'warning', 'comment']);
             if (hasError)
             {
-                header.removeCls(['warning']);
-                header.removeCls(['comment']);
-                header.addCls('error')
+                header.addCls('error');
             }
             else if (hasWarn)
             {
-                header.removeCls(['error']);
-                header.removeCls(['comment']);
-                header.addCls('warning')
+                header.addCls('warning');
             }
             else if (hasComment)
             {
-                header.removeCls(['error']);
-                header.removeCls(['warning']);
-                header.addCls('comment')
-            }
-            else
-            {
-                header.removeCls(['error', 'warning', 'comment']);
+                header.addCls('comment');
             }
             
             if (header.rendered)
             {
-                this._createTabTooltip (header, panel, errorFields, warnFields, commentFields);
+            	// As we change width with CSS we have to prevent tabs from overlapping one another
+            	header.updateLayout();
+            	
+                this._createTabTooltip (header, panel, errors, warnings, commentFields);
             }
             else
             {
@@ -1046,6 +1019,12 @@
             {
                 header.removeCls(['empty']);
             }
+            
+            var focusedTool = Ametys.tool.ToolsManager.getFocusedTool();
+            if (focusedTool != null && this._formReady && !focusedTool.isDirty())
+        	{
+            	focusedTool.setDirty(true);
+        	}	
         }
     },
     
@@ -1053,7 +1032,7 @@
      * @private
      * Show or hide the elements of a fieldset, including the parameter checkers
      * @param {Ext.form.field.Checkbox} checkbox the checkbox 
-     * @param {Ext.panel.Panel} fieldset the fieldset the group switchs belongs to
+     * @param {Ext.panel.Panel} fieldset the fieldset the group switch belongs to
      * @param {Boolean} startup true if this is the first call, false otherwise
      */
     _showHideFieldset: function(checkbox, fieldset, startup)
@@ -1061,21 +1040,30 @@
         Ext.suspendLayouts();
         
         var checked = checkbox.getValue();
+
         fieldset.items.eachKey(function(key){
-            var fieldsetElement = Ext.getCmp(key);
-            fieldsetElement.setVisible(checked);
-            
+        	
+        	var fieldsetElement = Ext.getCmp(key);
+        	if (fieldsetElement.getId() == checkbox.getId())
+    		{
+        		return;
+    		}
+
+        	fieldsetElement.setVisible(checked);
+        	
             if (fieldsetElement.hasCls('param-checker-container'))
             {
                 // parameter checker
-                fieldsetElement.down().paramChecker.setStatus(checked ? Ametys.form.ConfigurableFormPanel.ParameterChecker.STATUS_NOT_TESTED
+                fieldsetElement.down('button').paramChecker.setStatus(checked ? Ametys.form.ConfigurableFormPanel.ParameterChecker.STATUS_NOT_TESTED
                                                                       : Ametys.form.ConfigurableFormPanel.ParameterChecker.STATUS_HIDDEN);
             }
-            else if (!startup)
-            {
-                // validate fields on expanding
+        	else if (!startup)
+    		{
+        		// validate fields on expanding/collapsing
+        		// validation on hidden fields always returns true
                 fieldsetElement.validate();
-            }
+    		}
+            
         });
 
         if (checked)
@@ -1100,6 +1088,7 @@
     _preventClickPropagation: function(checkbox)
     {
         checkbox.getEl().on('click', function(event) {event.stopPropagation();})
+        // checkbox.show();
     },
     
     /**
@@ -1108,11 +1097,10 @@
      * @param {String} label The label of the fieldset
      * @param {Number} nestingLevel The nesting level of the fieldset.
      * @param {Object} switcher If the group can be switched on/off, the configuration object corresponding to the group-switch parameter. A config for #_createInputField.
-     * @param {String[]} fieldNames An array containing the names of the fields the switcher will show/hide 
      * @return {Ext.form.FieldSet} The created fieldset
      * @private
      */
-    _addFieldSet: function (ct, label, nestingLevel, switcher, fieldNames)
+    _addFieldSet: function (ct, label, nestingLevel, switcher)
     {
         var me = this;
         var fdCfg = {
@@ -1133,13 +1121,8 @@
             var switcherCfg  = Ext.apply ({minWidth: 20, style: ' '}, switcher);
             
             var switcherField = this._createInputField(switcherCfg);
-            
             switcherField.on('render', Ext.bind(this._preventClickPropagation, this));
             
-            // Register the switcher as a field
-            this._fields.push(switcherCfg.name);
-            this._switchers[switcherCfg.name] = switcherField;
-
             Ext.apply(fdCfg, {
                 title: switcherCfg.label,
                 
@@ -1148,6 +1131,8 @@
                 hideCollapseTool: true,
                 cls: 'ametys-fieldset',             
                 
+                tools: [switcherField],
+                
                 header: {
                     titlePosition: 1,
                     
@@ -1157,7 +1142,7 @@
                                 if (!switcherField.checked) 
                                 {
                                     // When the group is switched off, we cannot collapse/expand it
-                                    event.stopEvent();
+                                	event.stopEvent();
                                     return false;
                                 }
                                 else
@@ -1167,22 +1152,17 @@
                             }
                         } 
                     }
-            
                 },
                 
                 listeners: {
                     add: {
                         fn: function(){
                             // every time something is added to this panel we want to hide it depending on the switch value
-                            // hiding such element will make isValid works as we want
+                            // hiding such element will make isValid work as we want
                             me._showHideFieldset(switcherField, this, true);
                         }
                     }
-                },
-                
-                tools: [
-                    switcherField
-                ]
+                }
             });
         }
         else if (label)
@@ -1198,12 +1178,18 @@
         }
         
         var fieldset = new Ext.panel.Panel(fdCfg);
-
+        
+        // we need to add the switchfield here as a regular field in order for the form to consider it as a field immediately
+        // otherwise tools of the header are only added during rendering
+        // The field will be moved from the fieldset to the head automatically since a component cannot be used twice
+        fieldset.add(switcherField);
+        
         if (switcherField != null)
         {
             switcherField.on('change', Ext.bind(this._showHideFieldset, this, [fieldset, false], 1));
         }
         ct.add(fieldset);
+        
         return fieldset;
     },
     
@@ -1232,7 +1218,7 @@
         var field = this._createInputField(config);
         if (startVisible == 'false')
         {
-            field.hide();
+           field.hide();
         }
         
         if (field != null)
@@ -1280,9 +1266,12 @@
         Ext.applyIf (fieldCfg, {
             cls: 'ametys',
             style: config.style || 'margin-right:' + Math.max(60 - roffset, 0) + 'px',
+            
             labelAlign: 'right',
             labelWidth: Ametys.form.ConfigurableFormPanel.LABEL_WIDTH - offset,
+            labelPad: Ametys.form.ConfigurableFormPanel.LABEL_PADDING,
             labelSeparator: '',
+            
             minWidth: config.minWidth || Ametys.form.ConfigurableFormPanel.LABEL_WIDTH - offset + Ametys.form.ConfigurableFormPanel.FIELD_MINWIDTH,
             anchor: '100%',
             
@@ -1511,7 +1500,7 @@
      * - String **role** Can be "tabs" or "fieldsets" to create a tab grouping or a fieldset grouping. Note that tab grouping can be replaced by simple panels according to a user preference.
      * - String **label** The label of the grouping.
      * - Object **switcher** The configuration of the switcher parameter. The switcher is a boolean field that is used to enable/disable the other fields of its fieldset (available for fieldsets that have a "fieldset" role exclusively).
-     *   It must have a **label** and an **id** (the id of the boolean field) and optionally a **defaultValue**. This configuration will be ignored if there is a **paramChecker** defined for the fieldset.
+     *   It must have a **label** and an **id** (the id of the boolean field) and optionally a **defaultValue**.
      * - Object **param-checker** (see above) Fieldsets can also have a parameter checker for both "tab" and "fieldset" role
      * - Object **elements** The child elements of the grouping : this is a recursive data object, except that **"fieldsets"** can not be used again with the role "tab".
      * 
@@ -1572,7 +1561,7 @@
                     var fieldsets = data[name];
                     for (var i=0; i < fieldsets.length; i++)
                     {
-                        if (role == 'fieldset')
+                        if (fieldsets[i].role == 'fieldset')
                         {
                             var elements = fieldsets[i].elements;
                             
@@ -1582,15 +1571,9 @@
                                 switcherCfg.name = switcherCfg.id;
                                 delete switcherCfg.id;
                                 switcherCfg.type = 'boolean';
-                                
-                                var fieldNames = [];
-                                for (var fieldId in elements)
-                                {
-                                    fieldNames.push(fieldId);
-                                }
                             }
                             
-                            var fieldset = this._addFieldSet(ct, fieldsets[i].label, nestingLevel, switcherCfg, fieldNames);
+                            var fieldset = this._addFieldSet(ct, fieldsets[i].label, nestingLevel, switcherCfg);
                             
                             // Transmit offset + 5 (padding) + 1 (border) + 11 (margin + border) if we are in a nested composite.
                             var finalOffset = offset 
@@ -1612,7 +1595,7 @@
                                 }
                                 
                                 Ext.Array.each(paramCheckers, function(paramChecker){
-                                    me._paramCheckersDAO.addGroupChecker(fieldset, paramChecker);
+                                    me._paramCheckersDAO.addGroupChecker(fieldset, paramChecker, finalOffset, finalROffset);
                                 });
                             }
                         }
@@ -1667,11 +1650,11 @@
                 }
                 else
                 {
-                    var metadata = data[name];
+                    var fieldData = data[name];
                     
-                    var label = metadata.label;
-                    var description = metadata.description;
-                    var isMandatory = metadata.validation ? (metadata.validation.mandatory) || false : false;
+                    var label = fieldData.label;
+                    var description = fieldData.description;
+                    var isMandatory = fieldData.validation ? (fieldData.validation.mandatory) || false : false;
                     
                     var widgetCfg = {
                         name: prefix + name,
@@ -1683,13 +1666,15 @@
                         showAmetysComments: this.showAmetysComments,
                         
                         mandatory: isMandatory,
-                        value: metadata['default-value'],
+                        value: fieldData['default-value'],
                         
-                        multiple: metadata.multiple,
-                        widget: metadata.widget,
+                        multiple: fieldData.multiple,
+                        widget: fieldData.widget,
                         
-                        hidden: metadata.hidden, 
-                        disabled: metadata['can-not-write'] === true,
+                        hidden: fieldData.hidden, 
+                        disabled: fieldData['can-not-write'] === true,
+                        
+                        disableCondition: fieldData.disableCondition,
                         
                         form: this,
                         offset: offset,
@@ -1698,12 +1683,12 @@
 
                     // Add configured configuration
                     Ext.Object.each(this._additionnalWidgetsConf, function(key, value, object) {
-                        widgetCfg[key] = metadata[value];
+                        widgetCfg[key] = fieldData[value];
                     });
                     
-                    if (metadata.validation)
+                    if (fieldData.validation)
                     {
-                        var validation = metadata.validation;
+                        var validation = fieldData.validation;
                         widgetCfg.regexp = validation.regexp || null;
                         
                         if (validation.invalidText)
@@ -1716,11 +1701,11 @@
                         }
                     }
                     
-                    if (metadata.enumeration)
+                    if (fieldData.enumeration)
                     {
                         var enumeration = [];
                         
-                        var entries = metadata.enumeration;
+                        var entries = fieldData.enumeration;
                         for (var j=0; j < entries.length; j++)
                         {
                             enumeration.push([entries[j].value, entries[j].label]);
@@ -1729,19 +1714,19 @@
                         widgetCfg.enumeration = enumeration;
                     }
                     
-                    if (metadata['widget-params'])
+                    if (fieldData['widget-params'])
                     {
-                        widgetCfg = Ext.merge (widgetCfg, metadata['widget-params']);
+                        widgetCfg = Ext.merge (widgetCfg, fieldData['widget-params']);
                     }
                     
-                    if (metadata.annotations)
+                    if (fieldData.annotations)
                     {
                         var annotations = [];
                         
-                        var entries = metadata.annotations;
+                        var entries = fieldData.annotations;
                         for (var j=0; j < entries.length; j++)
                         {
-                            annotations.push({
+                        	fieldData.push({
                                 name: entries[j].name,
                                 label: entries[j].label || entries[j].name,
                                 description: entries[j].description || entries[j].label || entries[j].name
@@ -1753,7 +1738,7 @@
                     
                     this._addInputField(ct, widgetCfg);
                     
-                    var paramCheckers = metadata['param-checker'];
+                    var paramCheckers = fieldData['param-checker'];
                     if (!Ext.isEmpty(paramCheckers))
                     {
                         if (paramCheckers.length > 1)
@@ -1762,7 +1747,7 @@
                         }
                         
                         Ext.Array.each(paramCheckers, function(paramChecker){
-                            me._paramCheckersDAO.addGroupChecker(fieldset, paramChecker);
+                            me._paramCheckersDAO.addParameterChecker(fieldset, paramChecker, offset, roffset);
                         });
                     }
                 }
@@ -1786,7 +1771,7 @@
                     this._configureJSON (tabs[i].elements, prefix, tab, finalOffset, finalROffset);
                 
                     // Add the parameter checker at the end of the current tab
-                    var paramCheckers = metadata['param-checker']
+                    var paramCheckers = tabs[i]['param-checker'];
                     if (!Ext.isEmpty(paramCheckers))
                     {
                         if (paramCheckers.length > 1)
@@ -1794,7 +1779,7 @@
                             paramCheckers.sort(me._compareByOrder);
                         }
                         Ext.Array.each(paramCheckers, function(paramChecker) {
-                            me._paramCheckersDAO.addCategoryChecker(tab, paramChecker);
+                            me._paramCheckersDAO.addCategoryChecker(tab, paramChecker, finalOffset, finalROffset);
                         });
                     }
                 }
@@ -1810,7 +1795,7 @@
      * @param {Number} [offset=0] The field offset.
      * @param {Number} [roffset=0] The field right offset.
      */
-    _configureXML: function (metadataNode, prefix, ct, offset, roffset)
+    _configureXML: function (data, prefix, ct, offset, roffset)
     {
             prefix = prefix || this.getFieldNamePrefix();
             ct = ct || this._getFormContainer();
@@ -1819,7 +1804,7 @@
             
             var me = this;
             
-            var nodes = Ext.dom.Query.selectDirectElements(null, metadataNode);
+            var nodes = Ext.dom.Query.selectDirectElements(null, data);
             
             var tabs = [];
             
@@ -1866,20 +1851,9 @@
                             switcherCfg.label = Ext.dom.Query.selectValue('> label', switcher);
                             switcherCfg.defaultValue = Ext.dom.Query.selectValue('> defaultValue', switcher);
                             switcherCfg.type = 'boolean';
-                            
-                            // Gather the names of the other fields into an array
-                            var fieldNames = [];
-                            for (var j=0; j < elements.childNodes.length; j++)
-                            {
-                                var elementId = elements.childNodes[j].tagName;
-                                if (elementId != switcherCfg.id)
-                                {
-                                    fieldNames.push(elementId);
-                                }
-                            }
                         }
                         
-                        var fieldset = this._addFieldSet(ct, label, nestingLevel, switcher != null ? switcherCfg : null, fieldNames);
+                        var fieldset = this._addFieldSet(ct, label, nestingLevel, switcher != null ? switcherCfg : null);
 
                         // Transmit offset + 5 (padding) + 1 (border) + 11 (margin + border) if we are in a nested composite.
                         var finalOffset = offset 
@@ -1912,7 +1886,7 @@
                                     'order':  Ext.dom.Query.selectValue("> order", paramChecker)
                                 };
                                 
-                                me._paramCheckersDAO.addGroupChecker(fieldset, paramCheckerConf);
+                                me._paramCheckersDAO.addGroupChecker(fieldset, paramCheckerConf, finalOffset, finalROffset);
                             });
                         }
                     }
@@ -1969,7 +1943,6 @@
                     
                     var widgetCfg = {
                         name: prefix + name,
-                        metadataName: name,
                         type: Ext.dom.Query.selectValue("> type", nodes[i]),
                         
                         fieldLabel: (isMandatory ? '* ' : '') + label,
@@ -1988,8 +1961,7 @@
                         // custom validator to bypass validation on hidden values (groups switched off)
                         validator: function(value)
                         {   
-                            var field = me.getField(name);
-                            if(!field.isVisible() || field.isDisabled())
+                            if(!this.isVisible() || this.isDisabled())
                             {
                                 return true;
                             }
@@ -2084,7 +2056,7 @@
                                 'order':  Ext.dom.Query.selectValue("> order", paramChecker)
                             };
                             
-                            me._paramCheckersDAO.addParameterChecker(paramCheckerConf);
+                            me._paramCheckersDAO.addParameterChecker(paramCheckerConf, offset, roffset);
                         })
                     }
                 }
@@ -2133,7 +2105,7 @@
                                 'order':  Ext.dom.Query.selectValue("> order", paramChecker)
                             };
                             
-                            me._paramCheckersDAO.addCategoryChecker(tab, paramCheckerConf);
+                            me._paramCheckersDAO.addCategoryChecker(tab, paramCheckerConf, finalOffset, finalROffset);
                         });
                     }
                 }
@@ -2156,7 +2128,7 @@
     },
 
     /**
-     * Fill a configured form with values. #configure must have been call previously with data corresponding to these data.
+     * Fill the configured form with values. #configure must have been called previously with data matching the configured data.
      * 
      * The data can be an XML or a JSON object.
      * 
@@ -2166,24 +2138,24 @@
      * 
      * 
      *      <myrootnode>
-     *          <metadata>
+     *          <values>
      *              <fieldname json="false" value="3"/>
      *              <!-- ... -->
-     *          </metadata>
+     *          </values>
      *          
      *          <comments>
-     *              <metadata path="fieldname">
+     *              <field path="fieldname">
      *                  <comment id="1" date="2020-12-31T23:59:59.999+02:00">
      *                      My comment for the field <fieldname>
      *                  </comment>
      *                  <!-- ... -->
-     *              </metadata>
+     *              </field>
      *              <!-- ... -->
      *          </comments>
      *      </myrootnode>
      * 
      * 
-     * For the values, the tag **metadata** is the wrapping for tags holding the values:
+     * For the values, the tag **metadata** is the wrapping for tags holding the values and its name is configurable (see **valuesTagName** parameter):
      * 
      * - the tag name is the name of the concerned field (without prefix).
      * - thoses tags are recursive for sub-field (child of composites).
@@ -2192,15 +2164,15 @@
      * - the value itself can be either the value of the attribute **value**, or the text of the tag
      * - multiple values are set by repeating the tag.
      *   
-     * For the **comments**:
+     * For the comments, the tag **comments** is the wrapping tag and its name is configurable (see **commentsTagName** parameter):
      * 
-     * - the **metadata** are not recursive
+     * - the **metadata** are not recursive 
      * - the **path** attribute contains the fieldname (without prefix) with '/' separator for sub-fields (child of composites). For repeaters, you also have to add the position of the repeater to modify. Exemple: path="mycompositefield/myrepeater/2/myfield"
      * - the **comment** tag have the following mandatory attributes :
      *   - **id** The number of the comment
      *   - **date** The date of the comment using the ISO 8601 format (will use the Ext.Date.patterns.ISO8601DateTime parser).
      *   - **author** The fullname of the author of the comment.
-     *   
+     *  
      *  Here is a full example:
      *  
      *  
@@ -2295,16 +2267,23 @@
      * The **invalid** values should not set the same values already brought by **values**, but they will replace them in such a case.
      * 
      * @param {Object/HTMLElement} data The object that will fill the form.
+     * @param {String} valuesTagName the tag name for the values 
+     * @param {String} commentsTagName the tag name for the comments 
+     * @param {String} invalidFieldsTagName the tag name for the invalid fields
      */
-    setValues: function(data)
+    setValues: function(data, valuesTagName, commentsTagName, invalidFieldsTagName)
     {
-        if (this._isElement(data))
+    	valuesTagName = valuesTagName || "values";
+    	commentsTagName = commentsTagName || "comments";
+    	invalidFieldsTagName = invalidFieldsTagName || "invalid";
+    	
+    	if (this._isElement(data))
         {
-            this._setValuesXML(data);
+            this._setValuesXML(data, valuesTagName, commentsTagName);
         }
         else
         {
-            this._setValuesJSON(data);
+            this._setValuesJSON(data, valuesTagName, commentsTagName, invalidFieldsTagName);
         }
         
         this._formReady = true;
@@ -2316,30 +2295,33 @@
     /**
      * This function set the values of form fields from a XML dom.
      * @param {HTMLElement} xml The XML dom
+     * @param {String} valuesTagName the tag name for the values 
+     * @param {String} commentsTagName the tag name for the comments 
      * @private
      */
-    _setValuesXML: function (xml)
+    _setValuesXML: function (xml, valuesTagName, commentsTagName)
     {
         this._initializeTabsStatus();
         
-        var metadataNodes = Ext.dom.Query.select("metadata/*", xml);
+        var metadataNodes = Ext.dom.Query.select(valuesTagName + "/*", xml);
         for (var i=0; i < metadataNodes.length; i++)
         {
             this._setValuesXMLMetadata(metadataNodes[i], this.getFieldNamePrefix() + metadataNodes[i].tagName);
         }
         
-        this._setValuesXMLComments(Ext.dom.Query.selectNode("comments", xml));
+        this._setValuesXMLComments(Ext.dom.Query.selectNode(commentsTagName, xml));
     },
     
     /**
      * Set the values of form fields from an automatic backup.
      * @param {Object} data The backup data object.
      * @param {Object[]} data.repeaters The repeater item counts.
-     * @param {Object} data.values The valid field values.
-     * @param {Object} data.invalid The invalid field values.
+     * @param {String} valuesTagName the tag name for the values 
+     * @param {String} commentsTagName the tag name for the comments 
+     * @param {String} invalidFieldsTagName the tag name for the invalid fields
      * @private
      */
-    _setValuesJSON: function(data)
+    _setValuesJSON: function(data, valuesTagName, commentsTagName, invalidFieldsTagName)
     {
         this._initializeTabsStatus();
         
@@ -2387,13 +2369,13 @@
         }
         
         // Set the field values.
-        this._setValuesJSONForField(data.values);
+        this._setValuesJSONForField(data[valuesTagName]);
         
         // Set the invalid field values (raw mode) and validate the fields afterwards.
-        this._setValuesJSONForField(data.invalid, true, true);
+        this._setValuesJSONForField(data[invalidFieldsTagName], true, true);
         
         // Set the field comments.
-        this._setMetadataCommentsJSON(data.comments)
+        this._setMetadataCommentsJSON(data[commentsTagName])
     },
     
     /**
